/*
 * Cosmos - an xscreensaver module.
 * Tom Campbell and Jim Tanner Oct 2000 <campbell@mindspring.com>
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This file is provided AS IS with no warranties of any kind.  The author
 * shall have no liability with respect to the infringement of copyrights,
 * trade secrets or any patents by this file or any part thereof.  In no
 * event will the author be liable for any lost revenue or profits or
 * other special, indirect and consequential damages.
 *
 * Portions of this software were inspired by the late Seumas MacNally.
 * http://www.gamedev.net/community/memorial/seumas/
 *
 * $Id: actor.h,v 1.2 2001/02/14 05:32:50 jtanner Exp $
 */

// Forward declaration
class CActor;

#ifndef __actor__
#define __actor__

#include "cosmos.h"
#include "script.h"

extern "C" {
#include "screenhack.h"
}

// scripts
#define EXPLODE 0
#define FOLLOW  1

//
#define SPEED 30
#define BURSTTHROTTLE 50

class CActor 
{
 public:
	CActor(CCosmos *cosmos);
	CActor(CCosmos *cosmos,int x,int y);
	CActor(CCosmos *cosmos,int x,int y, CScript *script);
	void Init(int x,int y, CScript *script);
	void Script_SetBlastCount(int);
	void Reset(int x,int y, CScript *script);
	void SetLeader(CActor *leader);
	~CActor();

  private:
	friend class CScript;
	friend class CChaseScript;
	friend class CExplodeScript;
	float m_x;
	float m_y;
	CActor *m_leader;
	int m_TotalClicks;
	int m_follow;
	int m_init;
	int m_count;
	float m_xdelta;
	float m_ydelta;
	int m_visible;
	CCosmos *cosmos;
	CScript *script;
	// Script Explode
	int blastcount;
};

#endif
